/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pr2cv3;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author mudromar
 */
public class CarWithAGenericHolder implements BicycleVisitor {
    private final List<AnyHolder<? extends Bicycle>> list = new ArrayList<AnyHolder<? extends Bicycle>>(4);
 
    @Override
    public void accept(Bicycle b) {
        AnyHolder<Bicycle> bh = new AnyHolder<Bicycle>(b);
        addHolder(bh);
    }
 
    @Override
    public void accept(MountainBike b) {
        AnyHolder<MountainBike> bh = new AnyHolder<MountainBike>(b);
        addHolder(bh);
    }
 
    @Override
    public void accept(RoadBike b) {
        AnyHolder<RoadBike> bh = new AnyHolder<RoadBike>(b);
        addHolder(bh);
    }
 
    private void addHolder(AnyHolder<? extends Bicycle> bicycleHolder) {
        if (list.size() < 4) {
            list.add(bicycleHolder);
        } else {
            throw new ArrayIndexOutOfBoundsException();
        }
    }
 
    public void print() {
        for (AnyHolder<? extends Bicycle> bh : list) {
            System.out
                    .println(bh.getClass().getSimpleName() + " holding " + bh.getBicycle().getClass().getSimpleName());
        }
    }
}
