/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pr2cv3;

/**
 *
 * @author mudromar
 */
public class MountainBike extends Bicycle {
    private String suspension;
 
    public MountainBike(
            int startCadence,
            int startSpeed,
            int startGear,
            Color color,
            String suspensionType) {
        super(startCadence,
                startSpeed,
                startGear, color);
        this.setSuspension(suspensionType);
    }
 
    public String getSuspension() {
        return this.suspension;
    }
 
    public void setSuspension(String suspensionType) {
        this.suspension = suspensionType;
    }
 
    @Override
    public void printDescription() {
        super.printDescription();
        System.out.println("The " + "MountainBike has a" +
                getSuspension() + " suspension.");
    }
 
    @Override
    public void visit(BicycleVisitor servis) {
        servis.accept(this);
    }
}
