/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pr2cv3;

/**
 *
 * @author mudromar
 */
public class RoadBike extends Bicycle {
    // In millimeters (mm)
    private int tireWidth;
 
    public RoadBike(int startCadence,
            int startSpeed,
            int startGear,
            Color color,
            int newTireWidth) {
        super(startCadence,
                startSpeed,
                startGear,
                color);
        this.setTireWidth(newTireWidth);
    }
 
    public int getTireWidth() {
        return this.tireWidth;
    }
 
    public void setTireWidth(int newTireWidth) {
        this.tireWidth = newTireWidth;
    }
 
    @Override
    public void printDescription() {
        super.printDescription();
        System.out.println("The RoadBike" + " has " + getTireWidth() +
                " MM tires.");
    }
 
    @Override
    public void visit(BicycleVisitor servis) {
        servis.accept(this);
    }
}
